#include "drivers/wifi/wifi_driver.h"
// #include "drivers/nfc/nfc_functions.h"
// #include "drivers/ble/ble_driver.h"

#include <stdio.h>
#include <stddef.h>
#include <stdbool.h>
#include <string.h>
#include <errno.h>
#include <zephyr/net/net_if.h>
#include <zephyr/logging/log.h>
#include <zephyr/kernel.h>

LOG_MODULE_REGISTER(main, CONFIG_LOG_DEFAULT_LEVEL);

//extern struct k_msgq nfc_msgq;  // Externe NFC message queue

int main(void)
{
    LOG_INF("Starting main application");

    // Initialize Wi-Fi, NFC, and Bluetooth with error handling
    wifi_init();
    // nfc_init();
    // init_bt(BLE_CENTRAL, BT_LE_SCAN_TYPE_ACTIVE, BT_LE_SCAN_OPT_FILTER_DUPLICATE, 
    //         BT_GAP_SCAN_FAST_INTERVAL, BT_GAP_SCAN_FAST_WINDOW);

    //nfc_wifi_data_t nfc_wifi_data;

    struct net_if *iface = net_if_get_first_wifi();
    if (!iface) {
        LOG_ERR("No Wi-Fi interface found!");
        return -1;
    }

    while (1) 
    {
        if (!net_if_is_up(iface)) {
            LOG_INF("Wi-Fi is down. Attempting to connect...");

            int err = wifi_connect("MUG_test", "mug_test");
            if (err == 0) {
                LOG_INF("Wi-Fi connection attempt started");
            } else {
                LOG_ERR("Failed to initiate Wi-Fi connection (Error: %d)", err);
            }
        } else {
            LOG_INF("Wi-Fi is already up");
        }

        k_sleep(K_SECONDS(5));  // Avoid constant retries, wait 5 seconds before checking again
    }
}